' Aufg22.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto

	Private Stand As Decimal
	Private Name As String
	Private Minimum As Decimal = 100D

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public ReadOnly Property Inhaber() As String
		Get
			Return Name
		End Get
	End Property

	Public Sub New(ByVal Name As String, ByVal betrag As Decimal)
		Me.Name = Name
		Stand = betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Auszahlen(ByVal betrag As Decimal)
		If Stand >= betrag Then Stand -= betrag
		If Stand <= Minimum Then
			RaiseEvent SaldoWarnung(Me, EventArgs.Empty)
		End If
	End Sub

	Public Event SaldoWarnung As EventHandler

End Class

Public Class Kunde

	Public Sub Reaktion(ByVal k As Object, ByVal e As EventArgs)
		Dim Giro As Konto = CType(k, Konto)
		Giro.Einzahlen(1000D)
	End Sub

End Class

Public Class Bank

	Public Sub Reaktion(ByVal k As Object, ByVal e As EventArgs)
		Dim Giro As Konto = CType(k, Konto)
		Console.WriteLine("Konto von " & Giro.Inhaber & " kurz vor Unterdeckung!")
	End Sub
End Class

'public delegate void Zahlung()

Public Module Aufg22

	Public Sub Main()
		Dim K As New Kunde
		Dim Giro As New Konto("Schulze", 3000D)
		AddHandler Giro.SaldoWarnung, AddressOf K.Reaktion
		Dim B As New Bank
		AddHandler Giro.SaldoWarnung, AddressOf B.Reaktion

		Giro.Auszahlen(2000D)
		Console.WriteLine(Giro.Saldo)
		Giro.Auszahlen(500D)
		Console.WriteLine(Giro.Saldo)
		Giro.Auszahlen(430D)
		Console.WriteLine(Giro.Saldo)
		Giro.Auszahlen(50D)
		Console.WriteLine(Giro.Saldo)
	End Sub
End Module
