' Bspl050.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto

	Private Stand As Decimal
	Private Inhaber As String

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String)
		Me.New(inhaber, 0)		 '(1)
	End Sub

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand += betrag + 10
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)	'(2)
		Stand += betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal, _
	ByVal waehrung As String)	  '(3)
		If (waehrung = "USD") Then
			Einzahlen(betrag * 1.1591D)			 '(4)
		Else
			Einzahlen(betrag)
		End If
	End Sub

	Public Sub Einzahlen(ByVal betrag() As Double)
		For i As Integer = 0 To betrag.Length - 1
			Einzahlen(CDec(betrag(i)))			 '(5)
		Next
	End Sub

	Public Sub Einzahlen(ByVal ParamArray betrag() As Decimal)
		For i As Integer = 0 To betrag.Length - 1
			Einzahlen(betrag(i))			 '(6)
		Next
	End Sub

	Public Sub Auszahlen(ByVal betrag As Decimal)	'(7)
		If Saldo >= betrag Then
			Stand -= betrag
		End If
	End Sub

End Class

Public Module Bspl050

	Public Sub Main()
		Dim Einzahlungen() As Double = {123.5, 12.85, 350}
		Dim Konto1 As Konto = New Konto("H. Meier")
		Dim Konto2 As Konto = New Konto("H. Meier", 500D)
		Console.WriteLine(Konto1.Saldo)
		Console.WriteLine(Konto2.Saldo)
		Konto1.Einzahlen(400D)
		Konto1.Einzahlen(Einzahlungen)
		Konto1.Einzahlen(125D, 340.5D, 1200D, 420.75D)
		Konto1.Einzahlen(100D, "USD")
		Console.WriteLine(Konto1.Saldo)
		Konto1.Auszahlen(400D)
		Console.WriteLine(Konto1.Saldo)
	End Sub
End Module
