' Bspl064.vb

Option Explicit On 
Option Strict On

Imports System

Public MustInherit Class Form '(1)

	Private Color As Integer
	Public Const Rot As Integer = 1
	Public Const Gruen As Integer = 2
	Public Const Blau As Integer = 4

	Public Property Farbe() As Integer
		Get
			Return Color
		End Get
		Set(ByVal value As Integer)
			If value < 8 Then Color = value
		End Set
	End Property

	Public Function FarbeToString() As String
		Select Case Color
			Case 0
				Return "schwarz"
			Case 1
				Return "rot"
			Case 2
				Return "grn"
			Case 3
				Return "gelb"
			Case 4
				Return "blau"
			Case 5
				Return "magenta"
			Case 6
				Return "cyan"
			Case 7
				Return "wei"
			Case Else
				Return "unbekannt"
		End Select
	End Function

	Public Overridable ReadOnly Property Flaeche() As Double	   '(2)
		Get
			Return 0			'(3)
		End Get
	End Property
End Class

Public Class Kreis : Inherits Form

	Protected R As Integer

	Public Sub New(ByVal r As Integer)
		Me.R = r
	End Sub

	Public Sub New()
	End Sub

	Public Overrides ReadOnly Property Flaeche() As Double	   '(4)
		Get
			Return Math.PI * Math.Pow(R, 2)
		End Get
	End Property
End Class

Public NotInheritable Class Ring '(5)
	Inherits Kreis

	Private L As Double

	Public Sub New(ByVal r As Integer, ByVal l As Double)
		Me.R = r
		Me.L = l
	End Sub

	Public Overrides ReadOnly Property Flaeche() As Double	'(6)
		Get
			Return MyBase.Flaeche - _
			 Math.PI * Math.Pow(L, 2)
		End Get
	End Property
End Class

Public Class Rechteck : Inherits Form

	Private A, B As Integer

	Public Sub New(ByVal a As Integer, ByVal b As Integer)
		Me.A = a
		Me.B = b
	End Sub

	Public Shadows ReadOnly Property Flaeche() As Double	  '(7)
		Get
			Return A * B
		End Get
	End Property
End Class

Module Bspl064
	Public Sub Main()
		Dim Liste(4) As Form		  '(8)
		Liste(0) = New Ring(10, 5)		 '(9)
		Liste(1) = New Kreis(4)
		Liste(2) = New Ring(5, 2)
		Liste(3) = New Rechteck(4, 3)
		Liste(4) = New Rechteck(10, 5)

		For I As Integer = 0 To Liste.Length - 1		   '(10)
			Console.WriteLine(Liste(I).ToString() _
			 & ": " & Liste(I).Flaeche)			 '(11)
		Next
	End Sub
End Module
