' Bspl068.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto '(1)

	Private Stand As Decimal
	Private Inhaber As String

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String)
		Me.New(inhaber, 0)
	End Sub

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand += betrag + 10
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal, _
	ByVal waehrung As String)
		If (waehrung = "USD") Then
			Einzahlen(betrag * 1.1591D)
		Else
			Einzahlen(betrag)
		End If
	End Sub

	Public Sub Einzahlen(ByVal betrag() As Double)
		For i As Integer = 0 To betrag.Length - 1
			Einzahlen(CDec(betrag(i)))
		Next
	End Sub

	Public Sub Einzahlen(ByVal ParamArray betrag() As Decimal)
		For i As Integer = 0 To betrag.Length - 1
			Einzahlen(betrag(i))
		Next
	End Sub

	Public Sub Auszahlen(ByVal betrag As Decimal)
		If Saldo >= betrag Then
			Stand -= betrag
		End If
	End Sub

End Class

Public Delegate Sub Zahlung(ByVal betrag As Decimal)   '(2)

Public Module Bspl068

	Public Sub Main()
		Dim Z1, Z2, Z3 As Zahlung		 '(3)
		Dim K1 As New Konto("Mller", 5000D)
		Dim K2 As New Konto("Meier", 2000D)
		Z1 = AddressOf K1.Einzahlen		  '(4)
		Z2 = AddressOf K2.Auszahlen		  '(5)
		Z3 = CType([Delegate].Combine(Z2, Z1), Zahlung)		'(6)
		Z3(500D)		  '(7)
		Console.WriteLine(K1.Saldo)
		Console.WriteLine(K2.Saldo)
		Z3 = CType([Delegate].Remove(Z3, Z1), Zahlung)		'(8)
		Z3(200D)
		Console.WriteLine(K1.Saldo)
		Console.WriteLine(K2.Saldo)
	End Sub
End Module
