' Bspl069.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto   '(1)

	Private Stand As Decimal
	Private Inhaber As String
	Private Minimum As Decimal = 100D	'(2)

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand = betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Auszahlen(ByVal betrag As Decimal)	'(3)
		If Stand >= betrag Then Stand -= betrag
		If Stand <= Minimum Then		   '(4)
			RaiseEvent SaldoWarnung()			  '(5
		End If
	End Sub

	Public Event SaldoWarnung As Zahlung	'(6)

End Class

Public Class Kunde

	Public Sub Reaktion()	 '(7)
		Console.WriteLine("Ich berweise bald einen Betrag.")		  '(8)
	End Sub

End Class

Public Delegate Sub Zahlung() '(9)

Public Module Bspl069
	Public Sub Main()
		Dim K As New Kunde
		Dim Giro As New Konto("Schulze", 3000D)
		AddHandler Giro.SaldoWarnung, AddressOf K.Reaktion
		Giro.Auszahlen(2000D)		  '(11)
		Console.WriteLine(Giro.Saldo)
		Giro.Auszahlen(500D)
		Console.WriteLine(Giro.Saldo)
		Giro.Auszahlen(430D)
		Console.WriteLine(Giro.Saldo)
		Giro.Auszahlen(50D)
		Console.WriteLine(Giro.Saldo)
	End Sub
End Module
